#include  <stdio.h>
#include  <string.h>

#include  "pmdata.h"
#include  "pmfunc.h"
#include  "pmtool.h"
#include  "oprprot.h"

/**********************************************************
 *     FUNCTION MODULE
 *                                        '93.1.12 by R.K
 *---------------------------------------------------------
 * module name : update_DB()
 *
 * input :
 *
 *output :
 *
 **********************************************************/
void update_DB(sn,buf)

     int  sn ;
     char *buf;
{

  char *wp, *wbp, wbuf[80], wbuf2[40], UpRev[40] ;
  char VerNO2[20], RevNO2[2048], DB_name2[20],info_buf[4096] ;
  char cdate[2048]; 
  char *dir, *DB_name, *VerNO1, *RevNO1, *DBsrc, *DBobj ;
  int ret, i, info_d, VersionNo2, RevsionNo2 ;
  FILE  *fp;

  /*** parameter set *************************************/
  if( (ret = pm_sep_prm(buf+1,prm_buf)) != 4 ){
    strcpy(wr_data,
    "result_update_DB(abnormal(\"invalid prm\"),\'&void\',done)\n");
    write(sn,wr_data,strlen(wr_data));
    return;
  }
  dir = prm_buf;                           /* get dir */
  DB_name = ((dir+strlen(dir))+1);         /* get DB_name */
  wp = ((DB_name+strlen(DB_name))+1);
  VerNO1 = opr_search_vstart(wp,0);        /* get VerNO1 */
  wp = opr_search_camma(VerNO1,0);
  wp[-1] = NULL;
  RevNO1 = wp;                             /* get RevNO1 */
  wp = opr_search_vend(RevNO1,0);
  wp[-1] = NULL;
  wp++;
  DBsrc = (wp+1);                           /* get DBsrc */
  DBobj = opr_search_camma(DBsrc,0);        /* get DBobj */
  DBobj[-1] = NULL;
  wp = opr_search_vend(DBobj,0);
  wp[-1] = NULL;

  /*** execute *******************************************/
  /*** change dir ***/
  pm_mkdir_name(dir,wbuf);
  if( (ret = opr_cd(wbuf)) == -1 ){
    strcpy(wr_data,
    "result_update_DB(abnormal(\"dir not found\"),\'&void\',done)\n");
    write(sn,wr_data,strlen(wr_data));
    return;
  }
  
  /*** read ".cntrl" file ***/
  sprintf(wbuf,"%s.cntrl",DB_name);
  if( (fp = fopen(wbuf,"r")) == NULL ){
    strcpy(wr_data,
    "result_update_DB(abnormal(\"DB not found\"),\'&void\',done)\n");
    write(sn,wr_data,strlen(wr_data));
    opr_cd(cur_dir);
    return;
  }

  /*** get DB_name & version from ".cntrl" file ***/
  fgets(DB_name2,sizeof(DB_name2),fp);
  DB_name2[strlen(DB_name2)-1] = NULL;
  fscanf(fp,"%d",&VersionNo2);
  fclose(fp);
  if( VersionNo2 < (atoi(VerNO1)) ){
    strcpy(wr_data,
    "result_update_DB(abnormal(\"DB not found\"),\'&void\',done)\n");
    write(sn,wr_data,strlen(wr_data));
    opr_cd(cur_dir);
    return;
  }

  /*** read ".info" file ***/
  sprintf(wbuf,"%s.%s.info",DB_name,VerNO1);
  if( (fp = fopen(wbuf,"r")) == NULL ){
    strcpy(wr_data,
    "result_update_DB(abnormal(\"Version not found\"),\'&void\',done)\n");
    write(sn,wr_data,strlen(wr_data));
    opr_cd(cur_dir);
    return;
  }

  /*** get revision from ".info" file ***/
  fgets(RevNO2,sizeof(RevNO2),fp);
  fgets(cdate,sizeof(cdate),fp);
  RevNO2[strlen(RevNO2)-1] = NULL;
  cdate[strlen(cdate)-1] = NULL;
  if( (info_d = opr_read(fp,info_buf,sizeof(info_buf))) < 0 )
    strcpy(info_buf,"\'&void\'");
  fclose(fp);

  /*** save data to file ***/
  if( (strcmp(DBsrc,"\'&void\'")) || (strcmp(DBobj,"\'&void\'")) ){
    sprintf(wbuf,"%s.%s.",DB_name2,VerNO1);
    wbp = wbuf+(strlen(wbuf));

    /*** update RevNO ***/
    sprintf(wbp,"info");
    if( (i = pm_update_rev(wbuf,RevNO2,cdate,info_buf,RevNO1,UpRev)) == -1 ){
      strcpy(wr_data,
      "result_update_DB(abnormal(\"Revsion not found\"),\'&void\',done)\n");
      write(sn,wr_data,strlen(wr_data));
      opr_cd(cur_dir);
      return;
    }
    pm_rep_rev(UpRev,wbuf2);

    /*** save DBsrc to file ***/
    if( strcmp(DBsrc,"\'&void\'") ){
      sprintf(wbp,"%s.src",wbuf2);
      fp = fopen(wbuf,"w");
      opr_write(fp,DBsrc,strlen(DBsrc));
      fclose(fp);
    }

    /*** save DBobj to file ***/
    if( strcmp(DBobj,"\'&void\'") ){
      sprintf(wbp,"%s.obj",wbuf2);
      fp = fopen(wbuf,"w");
      opr_write(fp,DBobj,strlen(DBobj));
      fclose(fp);
    }

    /*** make response data ***/
    sprintf(wr_data,"result_update_DB(normal,%s,done)\n",UpRev);
  }
  else
    strcpy(wr_data,
    "result_update_DB(normal,\'&void\',warning(\"don't save DB\"))\n");

  /*** response *******************************************/
  write(sn,wr_data,strlen(wr_data));
  opr_cd(cur_dir);
}
/***** <<< END OF c_updatedb.c >>> *****/
