/**************************************************************
 *        
 *    revision number
 *
 **************************************************************/

#include     <stdio.h>
#include     <string.h>
#include     <sys/types.h>

#define RNMAX 100

static char *n[RNMAX];
static short ni = 0;

/**************************************************************
 *
 *  n = add_revision(r);     
 *
 *  <input>
 *          char           *r      : revision number
 *
 *  <output>
 *          char           n       : 0  - 
 *				     -1 - error
 *
 *  <description>
 *
 **************************************************************/

int add_revision(r)
char *r;
	{
	if(ni < RNMAX)
		{
		n[ni] = strcpy(malloc(strlen(r)+1),r);
		return(ni++);
		}
	else
		return(-1);
	}

/**************************************************************
 *
 *  n = find_revision(r);     
 *
 *  <input>
 *          char           *r      : revision number
 *
 *  <output>
 *          char           n       : >=0 - found
 *				     -1  - not found
 *
 *  <description>
 *
 **************************************************************/

int find_revision(r)
char *r;
	{
	register i;

	for(i=0;i<ni;i++)
		{
		if(strcmp(n[i],r) == 0)
			return(i);
		}
	return(-1);
	}

/**************************************************************
 *
 *  n = dot_revision(r);     
 *
 *  <input>
 *          char           *r      : revision number
 *
 *  <output>
 *          char           n       : >=0 - found
 *				     -1  - not found
 *
 *  <description>
 *
 *	    search '.' backward, returns n (y.n)
 *
 **************************************************************/

int dot_revision(r)
char *r;
	{
	/* +++++++++++++++++++++++


	register i,j,k;

	for(i=0;i<ni;i++)
		{
		k = 0;
		for(j = strlen(n[i]);j > 0;j--)
			{
			if(n[i][j-1] == '.')
				return(k);
			else
				k += n[i][j-1] * (10**i);
			}
		}
	return(-1);
	}

/**************************************************************
 *
 *  nr = new_revision(r);     
 *
 *  <input>
 *          char           *r      : revision number to update
 *
 *  <output>
 *          char           *nr     : new revision number
 *
 *  <description>
 *
 **************************************************************/

char *new_revision(r)     
char *r;
	{
	char c[1000];
	int n;

	strcpy(c,r);
	strcat(c,".1");

	if(find_revision(c) < 0)
		{
		if((n = dot_revision(r)) < 0)
			
/***** <<< end of  >>> *********************************/
