#include "term.h"
extern char
	*strcpy(),
	*strncpy(),
	*strcat(),
	*strncat(),
	*strchr(),
	*strrchr(),
	*strpbrk(),
	*strtok(),
	*strdup();
extern char
	*memccpy(),
	*memchr(),
	*memcpy(),
	*memset();
extern int memcmp();
extern int
	strcmp(),
	strncmp(),
	strlen(),
	strspn(),
	strcspn();

Vector *new_vector(element_number)
int element_number;
{
  Vector *p;
  p = (Vector *)malloc(sizeof(Vector));
  p->id = is_vector;
  p->size = element_number;
  p->element = (Term *) calloc(element_number, sizeof(Term));
  return p;
}

Vector *list_to_vector(list)
     List *list;
{
  Vector * vector;
  vector = new_vector(count_list(list));
  if(NIL==list->head)
    return vector;
  else
    {
      int i = 0;
      while(list->tail !=NIL)
	{
	  vector->element[i] = *list->head;
	  list = list->tail;
	  i++;
	}
      vector->element[i] = *list->head;
    };
  return vector;
}

List *new_list(term)
Term *term;
{
  List *list;
  list = (List *)malloc(sizeof(List));
  list->id = is_list;
  list->head = term;
  return list;
}

List *append_list(list1, list2)
List *list1, *list2;
{
  List *list;
  for(list = list1; list->tail != NIL; list=list->tail);
  list->tail = list2;
  return list1;
}

int count_list(list)
     List *list;
{
  int count= 0;
  if(NIL==list->head)
    return 0;
  else
    {
      while(list->tail !=NIL)
	{ 
	  count++;
	  list = list->tail;
	};
      count++;
    };
  return count;
}

String *new_string(text)
char *text;
{
  String *string;
  int len;
  text++;
  len = strlen(text)-1;
  text[len] = '\0';
  string=(String *)malloc(sizeof(String));
  string->id = is_string;
  string->size = len;
  string->string = (char *)malloc(len+1); 
  strcpy(string->string, text);
  return string;
}

Atom *new_atom(text)
char *text;
{
  Atom *atom;
  atom = (Atom *)malloc(sizeof(Atom));
  atom->id = is_atom;
  atom->size = strlen(text);
  atom->string = (char *)malloc(atom->size+1); 
  strcpy(atom->string, text);
  return atom;
}

Qatom *new_qatom(text)
char *text;
{
  Qatom *qatom;
  qatom = (Qatom *)malloc(sizeof(Qatom));
  qatom->id = is_qatom;
  qatom->size = strlen(text);
  qatom->string = (char *)malloc(qatom->size+1); 
  strcpy(qatom->string, text);
  return qatom;
}

Integer *new_integer(text)
char *text;
{
  Integer *integer;
  integer = (Integer *)malloc(sizeof(Integer));
  integer->id = is_integer;
  integer->size = strlen(text);
  integer->string = (char *)malloc(integer->size+1); 
  strcpy(integer->string, text);
  return integer;
}

Variable *new_variable(text)
char *text;
{
  Variable *variable;
  variable = (Variable *)malloc(sizeof(Variable));
  variable->id = is_variable;
  variable->size = strlen(text);
  variable->string = (char *)malloc(variable->size+1); 
  strcpy(variable->string, text);
  return variable;
}
